diff --git a/kernel/ptrace.c b/kernel/ptrace.c
index 4c8bcd7..8d19d04 100644  
--- a/kernel/ptrace.c
+++ b/kernel/ptrace.c
@@ -16,6 +16,7 @@
 #include <linux/pagemap.h>
 #include <linux/smp_lock.h>
 #include <linux/ptrace.h>
+#include <linux/utrace.h>
 #include <linux/security.h>
 #include <linux/signal.h>
 #include <linux/audit.h>
@@ -38,6 +39,7 @@ void __ptrace_link(struct task_struct *c
 	child->parent = new_parent;
 }
  
+#ifndef CONFIG_UTRACE_PTRACE
 /*
  * Turn a tracing stop into a normal stop now, since with no tracer there
  * would be no way to wake it up with SIGCONT or SIGKILL.  If there was a
@@ -58,6 +60,72 @@ static void ptrace_untrace(struct task_s
 	spin_unlock(&child->sighand->siglock);
 }
 
+static void ptrace_finish(struct task_struct *child)
+{
+	if (task_is_traced(child))
+		ptrace_untrace(child);
+}
+
+static void ptrace_detach_task(struct task_struct *child, int sig)
+{
+	/* Architecture-specific hardware disable .. */
+	ptrace_disable(child);
+	clear_tsk_thread_flag(child, TIF_SYSCALL_TRACE);
+}
+
+static void utrace_engine_put(struct utrace_attached_engine *engine)
+{
+}
+
+#else  /* CONFIG_UTRACE_PTRACE */
+
+static const struct utrace_engine_ops ptrace_utrace_ops; /* forward decl */
+
+static void ptrace_detach_task(struct task_struct *child, int sig)
+{
+	enum utrace_resume_action action = UTRACE_DETACH;
+	struct utrace_attached_engine *engine;
+	int ret;
+
+	engine = utrace_attach_task(child, UTRACE_ATTACH_MATCH_OPS,
+				    &ptrace_utrace_ops, NULL);
+	if (unlikely(IS_ERR(engine)))
+		return;
+
+	/*
+	 * When leaving a parting signal to deliver, we cannot detach our
+	 * utrace engine yet.  We need it there to get a report_signal()
+	 * callback that can inject our parting signal.  Instead, we'll
+	 * mark our engine by clearing its data pointer.  Our callbacks
+	 * will see this and know it's a PTRACE_DETACH still in progress.
+	 */
+	if (sig) {
+		engine->data = NULL;
+		action = UTRACE_INTERRUPT;
+	}
+
+	ret = utrace_control(child, engine, action);
+	WARN_ON(ret && ret != -EINPROGRESS &&
+		ret != -ESRCH && ret != -EALREADY);
+
+	utrace_engine_put(engine);
+}
+
+void ptrace_utrace_exit(struct task_struct *task)
+{
+	struct task_struct *child;
+	read_lock(&tasklist_lock);
+	list_for_each_entry(child, &task->ptraced, ptrace_entry)
+		ptrace_detach_task(child, 0);
+	read_unlock(&tasklist_lock);
+}
+
+static void ptrace_finish(struct task_struct *child)
+{
+}
+
+#endif	/* !CONFIG_UTRACE_PTRACE */
+
 /*
  * unptrace a task: move it back to its original parent and
  * remove it from the ptrace list.
@@ -72,10 +140,11 @@ void __ptrace_unlink(struct task_struct 
 	child->parent = child->real_parent;
 	list_del_init(&child->ptrace_entry);
 
-	if (task_is_traced(child))
-		ptrace_untrace(child);
+	ptrace_finish(child);
 }
 
+#ifndef CONFIG_UTRACE_PTRACE
+
 /*
  * Check that we have indeed attached to the thing..
  */
@@ -113,6 +182,536 @@ int ptrace_check_attach(struct task_stru
 	return ret;
 }
 
+static struct utrace_attached_engine *prepare_ptrace_attach(
+	struct task_struct *child, struct task_struct *parent)
+{
+	return NULL;
+}
+
+static int finish_ptrace_attach(struct task_struct *task,
+				 struct utrace_attached_engine *engine,
+				 int retval)
+{
+	return retval;
+}
+
+static int ptrace_update_utrace(struct task_struct *task,
+				struct utrace_attached_engine *engine)
+{
+	return 0;
+}
+
+#else	/* CONFIG_UTRACE_PTRACE */
+
+static int ptrace_update_utrace(struct task_struct *task,
+				struct utrace_attached_engine *engine)
+{
+	unsigned long events;
+
+	/*
+	 * We need this for resume handling.
+	 */
+	events = UTRACE_EVENT(QUIESCE);
+
+	/*
+	 * These events are always reported.
+	 */
+	events |= UTRACE_EVENT(EXEC) | UTRACE_EVENT_SIGNAL_ALL;
+
+	/*
+	 * We always have to examine clone events to check for CLONE_PTRACE.
+	 */
+	events |= UTRACE_EVENT(CLONE);
+
+	/*
+	 * PTRACE_SETOPTIONS can request more events.
+	 */
+	if (task->ptrace & PT_TRACE_EXIT)
+		events |= UTRACE_EVENT(EXIT);
+
+	if (!engine) {
+		int ret;
+		engine = utrace_attach_task(task, UTRACE_ATTACH_MATCH_OPS,
+					    &ptrace_utrace_ops, NULL);
+		if (IS_ERR(engine))
+			return -ESRCH;
+		ret = utrace_set_events(task, engine, events);
+		utrace_engine_put(engine);
+		return ret;
+	}
+
+	return utrace_set_events(task, engine, events);
+}
+
+static int ptrace_unsafe_exec(struct utrace_attached_engine *engine,
+			      struct task_struct *task)
+{
+	if (task->ptrace & PT_PTRACE_CAP)
+		return LSM_UNSAFE_PTRACE_CAP;
+
+	return LSM_UNSAFE_PTRACE;
+}
+
+static struct task_struct *ptrace_tracer_task(
+	struct utrace_attached_engine *engine, struct task_struct *target)
+{
+	return target->parent;
+}
+
+static void ptrace_set_action(struct task_struct *task,
+			      enum utrace_resume_action action,
+			      enum utrace_syscall_action syscall)
+{
+	task->ptrace &= ~((UTRACE_SYSCALL_MASK | UTRACE_RESUME_MASK) << 16);
+	task->ptrace |= ((UTRACE_RESUME - action) | syscall) << 16;
+}
+
+static enum utrace_resume_action ptrace_resume_action(struct task_struct *task)
+{
+	return UTRACE_RESUME - ((task->ptrace >> 16) & UTRACE_RESUME_MASK);
+}
+
+static enum utrace_syscall_action ptrace_syscall_action(
+	struct task_struct *task)
+{
+	return (task->ptrace >> 16) & UTRACE_SYSCALL_MASK;
+}
+
+/*
+ * Remember which event stop this was.  We have to keep a record that
+ * won't be wiped by ptrace_do_wait() when @task->exit_code is cleared.
+ * So we store the PTRACE_EVENT_* value in a nybble of @task->ptrace.
+ */
+static void ptrace_set_stop_event(struct task_struct *task, int event)
+{
+	task->ptrace &= 0xf0ffffffU;
+	task->ptrace |= event << 24;
+}
+
+static int ptrace_stop_event(struct task_struct *task)
+{
+	return (task->ptrace >> 24) & 0xf;
+}
+
+/*
+ * This doesn't really exist in the user API, but we pick an unused value
+ * encoded with ptrace_set_stop_event() to record when the last stop was
+ * for a syscall stop.
+ */
+#define PTRACE_EVENT_SYSCALL	0xf
+
+static u32 utrace_ptrace_report(u32 action, struct task_struct *task,
+				int event, int code)
+{
+	/*
+	 * Special kludge magic in utrace.c (utrace_stop) sees this
+	 * and calls do_notify_parent_cldstop() for us.  This kludge
+	 * is necessary to keep that wakeup after we enter TASK_TRACED.
+	 */
+	ptrace_set_action(task, UTRACE_STOP, 0);
+
+	/*
+	 * If we already have a pending stop event, then don't override it.
+	 * We'll simulate this stop when the pending one is cleared,
+	 * in ptrace_resume(), below.
+	 */
+	if (ptrace_stop_event(task) == 0) {
+		ptrace_set_stop_event(task, event);
+		task->exit_code = code;
+	}
+
+	return action | UTRACE_STOP;
+}
+
+static u32 utrace_ptrace_event(struct task_struct *task,
+			       int event, unsigned long msg)
+{
+	task->ptrace_message = msg;
+	return utrace_ptrace_report(0, task, event, (event << 8) | SIGTRAP);
+}
+
+static u32 ptrace_report_exec(enum utrace_resume_action action,
+			      struct utrace_attached_engine *engine,
+			      struct task_struct *task,
+			      const struct linux_binfmt *fmt,
+			      const struct linux_binprm *bprm,
+			      struct pt_regs *regs)
+{
+	if (task->ptrace & PT_TRACE_EXEC)
+		return utrace_ptrace_event(task, PTRACE_EVENT_EXEC, 0);
+
+	/*
+	 * Old-fashioned ptrace'd exec just posts a plain signal.
+	 */
+	send_sig(SIGTRAP, task, 0);
+	return UTRACE_RESUME;
+}
+
+static u32 ptrace_report_exit(enum utrace_resume_action action,
+			      struct utrace_attached_engine *engine,
+			      struct task_struct *task,
+			      long orig_code, long *code)
+{
+	return utrace_ptrace_event(task, PTRACE_EVENT_EXIT, *code);
+}
+
+static u32 ptrace_report_clone(enum utrace_resume_action action,
+			       struct utrace_attached_engine *engine,
+			       struct task_struct *parent,
+			       unsigned long clone_flags,
+			       struct task_struct *child)
+{
+	int event;
+	struct utrace_attached_engine *child_engine;
+
+	if ((clone_flags & CLONE_VFORK) &&
+	    (parent->ptrace & PT_TRACE_VFORK_DONE)) {
+		/*
+		 * Stash the child PID for a PTRACE_EVENT_VFORK_DONE report,
+		 * even if we don't report this clone event itself.  Mark
+		 * that we vfork'd even if we don't actually stop here, so
+		 * that we'll know to do the vfork-done report.  (This
+		 * matters when is PTRACE_O_TRACEVFORKDONE set but
+		 * PTRACE_O_TRACEVFORK is not set.)
+		 */
+		int rc = utrace_control(parent, engine, UTRACE_REPORT);
+		WARN_ON(rc);
+		parent->ptrace_message = child->pid;
+		ptrace_set_stop_event(parent, PTRACE_EVENT_VFORK);
+	}
+
+	if (clone_flags & CLONE_UNTRACED)
+		return UTRACE_RESUME;
+
+	event = 0;
+	if (clone_flags & CLONE_VFORK) {
+		if (parent->ptrace & PT_TRACE_VFORK)
+			event = PTRACE_EVENT_VFORK;
+	} else if ((clone_flags & CSIGNAL) != SIGCHLD) {
+		if (parent->ptrace & PT_TRACE_CLONE)
+			event = PTRACE_EVENT_CLONE;
+	} else if (parent->ptrace & PT_TRACE_FORK) {
+		event = PTRACE_EVENT_FORK;
+	}
+
+	/*
+	 * Any of these reports implies auto-attaching the new child.
+	 * So does CLONE_PTRACE, even with no event to report.
+	 */
+	if (event || (clone_flags & CLONE_PTRACE)) {
+		child_engine = utrace_attach_task(child, UTRACE_ATTACH_CREATE |
+						  UTRACE_ATTACH_EXCLUSIVE |
+						  UTRACE_ATTACH_MATCH_OPS,
+						  &ptrace_utrace_ops,
+						  parent->parent);
+		if (unlikely(IS_ERR(child_engine))) {
+			WARN_ON(1);	/* XXX */
+		} else {
+			BUG_ON(!child->ptrace);
+			/* XXX already set by old ptrace code
+			   task_lock(child);
+			   child->ptrace = parent->ptrace;
+			   child->parent = parent->parent;
+			   task_unlock(child);
+			*/
+			ptrace_update_utrace(child, child_engine);
+			utrace_engine_put(child_engine);
+		}
+	}
+
+	if (event)
+		return utrace_ptrace_event(parent, event, child->pid);
+
+	return UTRACE_RESUME;
+}
+
+static u32 ptrace_report_syscall(u32 action, struct task_struct *task)
+{
+	int code = SIGTRAP;
+	if (task->ptrace & PT_TRACESYSGOOD)
+		code |= 0x80;
+	return utrace_ptrace_report(action, task, PTRACE_EVENT_SYSCALL, code);
+}
+
+static u32 ptrace_report_syscall_entry(u32 action,
+				       struct utrace_attached_engine *engine,
+				       struct task_struct *task,
+				       struct pt_regs *regs)
+{
+	/*
+	 * If we're doing PTRACE_SYSEMU, just punt here and report
+	 * at the exit stop instead.
+	 */
+	if (ptrace_syscall_action(task))
+		return UTRACE_SYSCALL_ABORT | UTRACE_RESUME;
+
+	return ptrace_report_syscall(UTRACE_SYSCALL_RUN, task);
+}
+
+/*
+ * Report a vfork-done event to precede another event report.
+ * There is no utrace callback associated directly with vfork-done.
+ * Instead, after seeing CLONE_VFORK in report_clone() we notice
+ * the following syscall-exit, signal, or quiesce callback and
+ * inject the PTRACE_EVENT_VFORK_DONE stop there.
+ */
+static u32 ptrace_report_vfork_done(struct task_struct *task)
+{
+	/*
+	 * We got here after a vfork, when vfork-done tracing
+	 * was enabled.
+	 */
+	ptrace_set_stop_event(task, 0);
+	return utrace_ptrace_event(task, PTRACE_EVENT_VFORK_DONE,
+				   task->ptrace_message);
+}
+
+static u32 ptrace_report_syscall_exit(enum utrace_resume_action action,
+				      struct utrace_attached_engine *engine,
+				      struct task_struct *task,
+				      struct pt_regs *regs)
+{
+	if (unlikely(ptrace_stop_event(task) == PTRACE_EVENT_VFORK))
+		return ptrace_report_vfork_done(task);
+
+	if (unlikely(ptrace_syscall_action(task)) &&
+	    unlikely(ptrace_resume_action(task) == UTRACE_SINGLESTEP))
+		/*
+		 * This is PTRACE_SYSEMU_SINGLESTEP.
+		 * Kludge: Prevent arch code from sending a SIGTRAP
+		 * after tracehook_report_syscall_exit() returns.
+		 */
+		user_disable_single_step(task);
+
+	return ptrace_report_syscall(0, task);
+}
+
+static u32 ptrace_resumed(struct task_struct *task,
+			  struct utrace_attached_engine *engine,
+			  siginfo_t *info, struct k_sigaction *return_ka)
+{
+	enum utrace_resume_action resume = ptrace_resume_action(task);
+
+	if (unlikely(ptrace_stop_event(task) == PTRACE_EVENT_VFORK))
+		return UTRACE_SIGNAL_REPORT | ptrace_report_vfork_done(task);
+
+	/*
+	 * If PTRACE_DETACH had a signal for us to deliver,
+	 * it didn't detach the engine, but marked it for us.
+	 */
+	if (!engine->data) {
+		read_lock(&tasklist_lock);
+		if (task->ptrace & PT_PTRACED)
+			engine->data = task->parent;
+		else
+			resume = UTRACE_DETACH;
+		read_unlock(&tasklist_lock);
+	}
+
+	/*
+	 * If we're stopping, or we haven't reported any signal,
+	 * then we're all done for now.
+	 */
+	if (resume == UTRACE_STOP || !task->last_siginfo)
+		return UTRACE_SIGNAL_REPORT | resume;
+
+	/*
+	 * We're resuming.  If there's no signal to deliver, just go.
+	 * If we were given a signal, deliver it now.
+	 */
+	WARN_ON(task->last_siginfo != info);
+	task->last_siginfo = NULL;
+	if (!task->exit_code)
+		return UTRACE_SIGNAL_REPORT | resume;
+
+	/* Update the siginfo structure if the signal has
+	   changed.  If the debugger wanted something
+	   specific in the siginfo structure then it should
+	   have updated *info via PTRACE_SETSIGINFO.  */
+	if (task->exit_code != info->si_signo) {
+		info->si_signo = task->exit_code;
+		info->si_errno = 0;
+		info->si_code = SI_USER;
+		info->si_pid = task_pid_vnr(task->parent);
+		info->si_uid = task->parent->uid;
+	}
+
+	task->exit_code = 0;
+
+	spin_lock_irq(&task->sighand->siglock);
+	*return_ka = task->sighand->action[info->si_signo - 1];
+	spin_unlock_irq(&task->sighand->siglock);
+
+	return UTRACE_SIGNAL_DELIVER | resume;
+}
+
+static u32 ptrace_report_signal(u32 action,
+				struct utrace_attached_engine *engine,
+				struct task_struct *task,
+				struct pt_regs *regs,
+				siginfo_t *info,
+				const struct k_sigaction *orig_ka,
+				struct k_sigaction *return_ka)
+{
+	switch (utrace_signal_action(action)) {
+	default:
+		WARN_ON(ptrace_stop_event(task) && info->si_signo != SIGKILL);
+		break;
+	case UTRACE_SIGNAL_HANDLER:
+		WARN_ON(ptrace_stop_event(task));
+		/*
+		 * A handler was set up.  If we are stepping, pretend
+		 * another SIGTRAP arrived.
+		 */
+		if (ptrace_resume_action(task) == UTRACE_SINGLESTEP ||
+		    ptrace_resume_action(task) == UTRACE_BLOCKSTEP) {
+			memset(info, 0, sizeof *info);
+			info->si_signo = SIGTRAP;
+			info->si_code = SIGTRAP;
+			info->si_pid = task_pid_vnr(task);
+			info->si_uid = task->uid;
+			break;
+		}
+		/* Fall through.  */
+	case UTRACE_SIGNAL_REPORT:
+		/*
+		 * This is not a new signal, but just a notification we
+		 * asked for.  Either we're stopping after another report
+		 * like exec or syscall, or we're resuming.
+		 */
+		return ptrace_resumed(task, engine, info, return_ka);
+	}
+
+	WARN_ON(!valid_signal(info->si_signo));
+	task->last_siginfo = info;
+	return utrace_ptrace_report(UTRACE_SIGNAL_IGN, task, 0, info->si_signo);
+}
+
+static u32 ptrace_report_quiesce(u32 action,
+				 struct utrace_attached_engine *engine,
+				 struct task_struct *task,
+				 unsigned long event)
+{
+	if (event == 0) {
+		task->last_siginfo = NULL;
+
+		if (unlikely(ptrace_stop_event(task) == PTRACE_EVENT_VFORK))
+			return ptrace_report_vfork_done(task);
+	}
+
+	return ptrace_resume_action(task);
+}
+
+static const struct utrace_engine_ops ptrace_utrace_ops = {
+	.tracer_task = ptrace_tracer_task,
+	.unsafe_exec = ptrace_unsafe_exec,
+	.report_signal = ptrace_report_signal,
+	.report_quiesce = ptrace_report_quiesce,
+	.report_exec = ptrace_report_exec,
+	.report_exit = ptrace_report_exit,
+	.report_clone = ptrace_report_clone,
+	.report_syscall_entry = ptrace_report_syscall_entry,
+	.report_syscall_exit = ptrace_report_syscall_exit,
+};
+
+/*
+ * Detach the utrace engine on error.  On success, set @engine->data to
+ * the ptracer's task_struct pointer.  This distinguishes an engine for
+ * attached ptrace from an engine left behind after a PTRACE_DETACH call
+ * that left a parting signal to deliver.
+ */
+static int finish_ptrace_attach(struct task_struct *task,
+				struct utrace_attached_engine *engine,
+				int retval)
+{
+	if (retval) {
+		int error = utrace_control(task, engine, UTRACE_DETACH);
+		WARN_ON(error && error != -ESRCH && error != -EALREADY);
+	} else {
+		engine->data = task->parent;
+	}
+	utrace_engine_put(engine);
+	return retval;
+}
+
+/*
+ * Attach a utrace engine for ptrace and set up its event mask.
+ * Returns the engine pointer or an IS_ERR() pointer.
+ */
+static struct utrace_attached_engine *prepare_ptrace_attach(
+	struct task_struct *child, struct task_struct *parent)
+{
+	struct utrace_attached_engine *engine;
+restart:
+	engine = utrace_attach_task(child, UTRACE_ATTACH_CREATE |
+				    UTRACE_ATTACH_EXCLUSIVE |
+				    UTRACE_ATTACH_MATCH_OPS,
+				    &ptrace_utrace_ops, parent);
+	if (engine == ERR_PTR(-EEXIST)) {
+		/*
+		 * There is already some ptrace engine attached.  Either
+		 * this attach will fail because another ptracer is
+		 * already attached, or else this engine was left behind
+		 * by PTRACE_DETACH to deliver a signal.
+		 */
+		engine = utrace_attach_task(child,
+					    UTRACE_ATTACH_MATCH_OPS,
+					    &ptrace_utrace_ops, NULL);
+		if (IS_ERR(engine)) {
+			BUG_ON(PTR_ERR(engine) != -ENOENT);
+			goto restart;
+		}
+		if (engine->data) {
+			utrace_engine_put(engine);
+			engine = ERR_PTR(-EEXIST);
+		}
+	}
+	if (IS_ERR(engine)) {
+		if (engine != ERR_PTR(-ESRCH))
+			engine = ERR_PTR(-EPERM);
+	} else {
+		int ret = ptrace_update_utrace(child, engine);
+		if (ret == -EINPROGRESS) {
+			ret = utrace_barrier(child, engine);
+			utrace_engine_put(engine);
+			if (ret != -ERESTARTSYS)
+				goto restart;
+			return ERR_PTR(-ERESTARTNOINTR);
+		}
+		if (ret)
+			engine = ERR_PTR(finish_ptrace_attach(child, engine,
+							      -ESRCH));
+	}
+	return engine;
+}
+
+int ptrace_check_attach(struct task_struct *child, int kill)
+{
+	struct utrace_attached_engine *engine;
+	struct utrace_examiner exam;
+	int ret;
+
+	engine = utrace_attach_task(child, UTRACE_ATTACH_MATCH_OPS,
+				    &ptrace_utrace_ops, NULL);
+	if (IS_ERR(engine))
+		return -ESRCH;
+
+	/*
+	 * Make sure our engine has already stopped the child.
+	 * Then wait for it to be off the CPU.
+	 */
+	ret = 0;
+	if (utrace_control(child, engine, UTRACE_STOP) ||
+	    utrace_prepare_examine(child, engine, &exam))
+		ret = -ESRCH;
+
+	utrace_engine_put(engine);
+
+	return ret;
+}
+
+#endif	/* !CONFIG_UTRACE_PTRACE */
+
 int __ptrace_may_access(struct task_struct *task, unsigned int mode)
 {
 	/* May we inspect the given task?
@@ -156,12 +755,17 @@ int ptrace_attach(struct task_struct *ta
 {
 	int retval;
 	unsigned long flags;
+	struct utrace_attached_engine *engine;
 
 	audit_ptrace(task);
 
 	retval = -EPERM;
 	if (same_thread_group(task, current))
-		goto out;
+		return retval;
+
+	engine = prepare_ptrace_attach(task, current);
+	if (unlikely(IS_ERR(engine)))
+		return PTR_ERR(engine);
 
 repeat:
 	/*
@@ -202,8 +806,8 @@ repeat:
 bad:
 	write_unlock_irqrestore(&tasklist_lock, flags);
 	task_unlock(task);
-out:
-	return retval;
+
+	return finish_ptrace_attach(task, engine, retval);
 }
 
 static inline void __ptrace_detach(struct task_struct *child, unsigned int data)
@@ -221,9 +825,7 @@ int ptrace_detach(struct task_struct *ch
 	if (!valid_signal(data))
 		return -EIO;
 
-	/* Architecture-specific hardware disable .. */
-	ptrace_disable(child);
-	clear_tsk_thread_flag(child, TIF_SYSCALL_TRACE);
+	ptrace_detach_task(child, data);
 
 	write_lock_irq(&tasklist_lock);
 	/* protect against de_thread()->release_task() */
@@ -309,6 +911,8 @@ static int ptrace_setoptions(struct task
 	if (data & PTRACE_O_TRACEEXIT)
 		child->ptrace |= PT_TRACE_EXIT;
 
+	ptrace_update_utrace(child, NULL);
+
 	return (data & ~PTRACE_O_MASK) ? -EINVAL : 0;
 }
 
@@ -367,6 +971,7 @@ static int ptrace_setsiginfo(struct task
 #define is_sysemu_singlestep(request)	0
 #endif
 
+#ifndef CONFIG_UTRACE_PTRACE
 static int ptrace_resume(struct task_struct *child, long request, long data)
 {
 	if (!valid_signal(data))
@@ -401,6 +1006,170 @@ static int ptrace_resume(struct task_str
 
 	return 0;
 }
+#else  /* CONFIG_UTRACE_PTRACE */
+static int ptrace_resume(struct task_struct *child, long request, long data)
+{
+	struct utrace_attached_engine *engine;
+	enum utrace_resume_action action;
+	enum utrace_syscall_action syscall;
+	int ret = 0;
+
+	if (!valid_signal(data))
+		return -EIO;
+
+	engine = utrace_attach_task(child, UTRACE_ATTACH_MATCH_OPS,
+				    &ptrace_utrace_ops, NULL);
+	if (IS_ERR(engine))
+		return -ESRCH;
+
+	syscall = UTRACE_SYSCALL_RUN;
+#ifdef PTRACE_SYSEMU
+	if (request == PTRACE_SYSEMU || request == PTRACE_SYSEMU_SINGLESTEP)
+		syscall = UTRACE_SYSCALL_ABORT;
+#endif
+
+	if (syscall != UTRACE_SYSCALL_RUN || request == PTRACE_SYSCALL) {
+		if (!(engine->flags & UTRACE_EVENT_SYSCALL) &&
+		    utrace_set_events(child, engine,
+				      engine->flags | UTRACE_EVENT_SYSCALL))
+			ret = -ESRCH;
+	} else if (engine->flags & UTRACE_EVENT(SYSCALL_ENTRY)) {
+		if (utrace_set_events(child, engine,
+				      engine->flags & ~UTRACE_EVENT_SYSCALL))
+			ret = -ESRCH;
+	}
+
+	action = UTRACE_RESUME;
+	if (is_singleblock(request)) {
+		if (unlikely(!arch_has_block_step()))
+			ret = -EIO;
+		action = UTRACE_BLOCKSTEP;
+	} else if (is_singlestep(request) || is_sysemu_singlestep(request)) {
+		if (unlikely(!arch_has_single_step()))
+			ret = -EIO;
+		action = UTRACE_SINGLESTEP;
+	}
+
+	if (!ret) {
+		/*
+		 * If there was a non-signal event reported last time,
+		 * we may need to simulate another event that follows
+		 * it, or do some other special case.  We'll set @event
+		 * nonzero here if there is an event to simulate.
+		 */
+		int event = ptrace_stop_event(child);
+		ptrace_set_stop_event(child, 0);
+
+		switch (event) {
+		case 0:
+			break;
+
+		default:
+			WARN_ON(1);
+		case PTRACE_EVENT_EXIT:
+			event = 0;
+			break;
+
+		case PTRACE_EVENT_FORK:
+		case PTRACE_EVENT_CLONE:
+		case PTRACE_EVENT_EXEC:
+		case PTRACE_EVENT_VFORK_DONE:
+			/*
+			 * At these events, @data is ignored.
+			 * After these there might be a syscall-exit stop.
+			 */
+			if (request == PTRACE_SYSCALL) {
+				data = SIGTRAP;
+				if (child->ptrace & PT_TRACESYSGOOD)
+					data |= 0x80;
+				ptrace_set_stop_event(child,
+						      PTRACE_EVENT_SYSCALL);
+			} else {
+				data = 0;
+				event = 0;
+			}
+			break;
+
+		case PTRACE_EVENT_SYSCALL:
+			/*
+			 * After a syscall stop, @data is treated specially.
+			 * It just queues the signal.
+			 */
+			if (data)
+				send_sig(data, child, 1);
+			data = 0;
+			event = 0;
+			break;
+
+		case PTRACE_EVENT_VFORK:
+			/*
+			 * For this event, @data is ignored.  We did have a
+			 * utrace stop right after, so on resuming there
+			 * can be a normal syscall-exit stop next if needed.
+			 * But we may need to simulate a vfork-done stop,
+			 * so we leave the marker in place.
+			 */
+			data = 0;
+			event = 0;
+			if (child->ptrace & PT_TRACE_VFORK_DONE) {
+				ptrace_set_stop_event(child,
+						      PTRACE_EVENT_VFORK);
+				action = UTRACE_REPORT;
+			}
+			break;
+		}
+
+		child->exit_code = data;
+
+		ptrace_set_action(child, action, syscall);
+
+		/*
+		 * Whatever action we want to resume with, we need to make
+		 * sure the child gets into ptrace_report_quiesce() so that
+		 * it clears last_siginfo before going back to user mode.
+		 */
+		if (child->last_siginfo)
+			action = UTRACE_REPORT;
+
+		if (event) {
+			/*
+			 * We have a stacked event.  That is, @child is
+			 * already at the last utrace stop point before
+			 * returning to user mode.  But the ptrace API
+			 * wants multiple stops on the way out.  Here the
+			 * original ptrace would resume the child and have
+			 * to stop again almost immediately.  Instead we
+			 * just leave it stopped and simulate the wake-up
+			 * and new stop by notifying the parent, i.e.
+			 * current's own thread group.
+			 */
+			read_lock(&tasklist_lock);
+			do_notify_parent_cldstop(child, CLD_TRAPPED);
+			read_unlock(&tasklist_lock);
+		} else {
+			if (task_is_stopped(child)) {
+				spin_lock_irq(&child->sighand->siglock);
+				child->signal->flags &= ~SIGNAL_STOP_STOPPED;
+				spin_unlock_irq(&child->sighand->siglock);
+			}
+
+			/*
+			 * To resume with a signal we must arrange
+			 * to enter ptrace_report_signal().
+			 */
+			if (data)
+				action = UTRACE_INTERRUPT;
+
+			if (utrace_control(child, engine, action))
+				ret = -ESRCH;
+		}
+	}
+
+	utrace_engine_put(engine);
+
+	return ret;
+}
+#endif	/* !CONFIG_UTRACE_PTRACE */
 
 int ptrace_request(struct task_struct *child, long request,
 		   long addr, long data)
@@ -480,6 +1249,11 @@ int ptrace_request(struct task_struct *c
 int ptrace_traceme(void)
 {
 	int ret = -EPERM;
+	struct utrace_attached_engine *engine;
+
+	engine = prepare_ptrace_attach(current, current->parent);
+	if (unlikely(IS_ERR(engine)))
+		return PTR_ERR(engine);
 
 	/*
 	 * Are we already being traced?
@@ -513,7 +1287,8 @@ repeat:
 		write_unlock_irqrestore(&tasklist_lock, flags);
 	}
 	task_unlock(current);
-	return ret;
+
+	return finish_ptrace_attach(current, engine, ret);
 }
 
 /**
diff --git a/kernel/signal.c b/kernel/signal.c
index 4530fc6..0e85826 100644  
--- a/kernel/signal.c
+++ b/kernel/signal.c
@@ -1419,7 +1419,7 @@ int do_notify_parent(struct task_struct 
 	return ret;
 }
 
-static void do_notify_parent_cldstop(struct task_struct *tsk, int why)
+void do_notify_parent_cldstop(struct task_struct *tsk, int why)
 {
 	struct siginfo info;
 	unsigned long flags;
@@ -1474,6 +1474,8 @@ static void do_notify_parent_cldstop(str
 	spin_unlock_irqrestore(&sighand->siglock, flags);
 }
 
+#ifndef CONFIG_UTRACE_PTRACE
+
 static inline int may_ptrace_stop(void)
 {
 	if (!likely(current->ptrace & PT_PTRACED))
@@ -1606,6 +1608,8 @@ void ptrace_notify(int exit_code)
 	spin_unlock_irq(&current->sighand->siglock);
 }
 
+#endif	/* !CONFIG_UTRACE_PTRACE */
+
 static void
 finish_stop(int stop_count)
 {
@@ -1683,6 +1687,7 @@ static int do_signal_stop(int signr)
 	return 1;
 }
 
+#ifndef CONFIG_UTRACE_PTRACE
 static int ptrace_signal(int signr, siginfo_t *info,
 			 struct pt_regs *regs, void *cookie)
 {
@@ -1721,6 +1726,13 @@ static int ptrace_signal(int signr, sigi
 
 	return signr;
 }
+#else
+static int ptrace_signal(int signr, siginfo_t *info,
+			 struct pt_regs *regs, void *cookie)
+{
+	return signr;
+}
+#endif
 
 int get_signal_to_deliver(siginfo_t *info, struct k_sigaction *return_ka,
 			  struct pt_regs *regs, void *cookie)
